plugins {
    java
    id("com.github.johnrengelman.shadow") version "7.1.2"
}

group = "de.limited_dev"
version = "0.1.0-alpha"

repositories {
    mavenCentral()
    maven("https://m2.dv8tion.net/releases")
}

dependencies {
    implementation("net.dv8tion:JDA:5.0.0-alpha.20")
    implementation("com.sedmelluq:lavaplayer:1.3.77")
    implementation("org.slf4j:slf4j-api:2.0.3")
    implementation("org.slf4j:slf4j-simple:2.0.3")
}

tasks.getByName<Test>("test") {
    useJUnitPlatform()
}

tasks.withType<Jar> {
    manifest {
        attributes["Main-Class"] = "de.limited_dev.lil_judd.Main"
    }
    // To add all of the dependencies
    from(sourceSets.main.get().output)

    dependsOn(configurations.runtimeClasspath)
    from({
        configurations.runtimeClasspath.get().filter { it.name.endsWith("jar") }.map { zipTree(it) }
    })
}


tasks.withType<com.github.jengelman.gradle.plugins.shadow.tasks.ShadowJar> {
    dependencies {
        include(dependency("net.dv8tion:JDA:5.0.0-alpha.20"))
        include(dependency("com.sedmelluq:lavaplayer:1.3.77"))
        include(dependency("org.slf4j:slf4j-api:2.0.3"))
        include(dependency("org.slf4j:slf4j-simple:2.0.3"))
    }

}

tasks.withType<JavaCompile>{
    options.encoding = "UTF-8"
}

java{
    sourceCompatibility = org.gradle.api.JavaVersion.VERSION_17
    targetCompatibility = org.gradle.api.JavaVersion.VERSION_17
}