package de.limited_dev.lil_judd.jdacommands.music;

import com.sedmelluq.discord.lavaplayer.player.AudioPlayer;
import com.sedmelluq.discord.lavaplayer.track.AudioTrack;
import com.sedmelluq.discord.lavaplayer.track.AudioTrackInfo;
import de.limited_dev.lil_judd.jdacommands.components.JDACommand;
import de.limited_dev.lil_judd.features.music.GuildMusicManager;
import de.limited_dev.lil_judd.features.music.MusicManager;
import de.limited_dev.lil_judd.util.EmbeddedMessageHelper;
import de.limited_dev.lil_judd.util.TimeUtil;
import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.events.interaction.command.SlashCommandInteractionEvent;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.BlockingQueue;

public class QueueCommand extends JDACommand {
    public QueueCommand() {
        super("queue");
    }

    @Override
    public void onSlashCommand(SlashCommandInteractionEvent event) {
        final Guild g = event.getGuild();
        final GuildMusicManager guildMusicManager = MusicManager.getInstance().getGuildMusicManager(g);
        final BlockingQueue<AudioTrack> queue = guildMusicManager.scheduler.queue;
        final AudioPlayer audioPlayer = guildMusicManager.audioPlayer;
        final AudioTrack currenttrack = audioPlayer.getPlayingTrack();

        if(queue.isEmpty() && currenttrack == null){
            EmbeddedMessageHelper.sendSimpleOneLiner(event, "Queue", "**Queue Empty**", null);
            return;
        }

        final List<AudioTrack> trackList = new ArrayList<>(queue);
        String description = "";
        AudioTrackInfo info;
        String trackInfo;
        int index = 0;
        info = currenttrack.getInfo();
        description = "**" + info.title + " - " + TimeUtil.getTimeFormatedShortend(info.length) + " (" + info.author + ")**\n";
        for(AudioTrack track : trackList){
            if(index == 14)
                continue;
            info = track.getInfo();
            trackInfo = info.title + " - " + TimeUtil.getTimeFormatedShortend(track.getDuration()) + " (" + info.author + ")\n";
            description = description + trackInfo;
            ++index;
        }

        EmbeddedMessageHelper.sendSimpleOneLiner(event, "Queue", description, "https://cdn.discordapp.com/attachments/833442323160891452/1031670452642394182/unknown.png");
    }
}
